# -*- coding: utf-8 -*-
"""
Created on Wed Jun  8 17:31:27 2016

@author: scd
"""
#### 1
import numpy as np 

data = np.loadtxt(open("data.csv",'rb'),delimiter=',',skiprows=1)
T = data[:,0]
y = data[:,1]

print 'number of rows: ', np.size(T)
print 'min: ', np.min(y)
print 'max: ',np.max(y)


import scipy.optimize as opt

def f(T,A,Ea):
    return A*np.exp(-Ea/(8.314*T))

params = opt.curve_fit(f,T,y,p0=[1000,10000])[0]
A,Ea = params

x = np.linspace(T[0],T[-1],200)
yfit = f(x,A,Ea)


import matplotlib.pyplot as plt
plt.figure()
plt.plot(x,yfit,label='fit')
plt.scatter(T,y,label='data')
plt.ylabel('y')
plt.xlabel('T')



##### 2
def eqs(x):
    y = np.zeros(3)
    y[0] = 2*x[0]+3*x[1]-5
    y[1] = x[0] - x[1] + x[2] -1
    y[2] = -x[0] - x[2]*3 + 2
    return y

x = opt.fsolve(eqs,[1,1,1])
print 'x = ', x[0], ' y = ', x[1], ' z = ', x[2]
#or
A = np.array([[2,3,0],[1,-1,1],[-1,0,-3]])
b = np.array([[5],[1],[-2]])
x = np.linalg.solve(A,b)
print 'x = ', x[0], ' y = ', x[1], ' z = ', x[2]


######## 3
import sympy as sp

x = sp.Symbol('x')
t = sp.Symbol('t')
f = sp.sin(x) + x*sp.exp(-t) + t**2
d = sp.diff(f,x)
i = sp.integrate(f,x)
i2 = sp.integrate(i,t)
print 'Derivative: ', d
print 'Integral: ', i2





######## 4
good = False
j = 0
while good == False:
    i = input('Give me a number ')
    if i == 5:
        break
    j += 1
    if j > 10:
        break
    
######## 5
from scipy.integrate import quad

y1 = 1
r = 5
k = .1
x = 3
def integral(f):
    return r*f**2 / (k*(r*f-f))


def func(x):
    return quad(integral,y1,x)[0] - np.log(x) - np.exp(x)

x = opt.fsolve(func,1)
print x












